diff -ur -X /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/kernel/open_pic.c linuxppc_2_4_devel-240/arch/ppc/kernel/open_pic.c
--- linuxppc_2_4_devel/arch/ppc/kernel/open_pic.c	Wed Jun  5 06:03:00 2002
+++ linuxppc_2_4_devel-240/arch/ppc/kernel/open_pic.c	Thu Jun  6 19:04:27 2002
@@ -33,6 +33,7 @@
 #endif
 
 void* OpenPIC_Addr;
+u_int OpenPIC_BootCPU;
 static volatile struct OpenPIC *OpenPIC = NULL;
 static int (*cascade_irq)(struct pt_regs *regs);
 
@@ -127,7 +128,7 @@
 #define DECL_THIS_CPU		int cpu = smp_hw_index[smp_processor_id()]
 #define CHECK_THIS_CPU		check_arg_cpu(cpu)
 #else
-#define THIS_CPU		Processor[0]
+#define THIS_CPU		Processor[OpenPIC_BootCPU]
 #define DECL_THIS_CPU
 #define CHECK_THIS_CPU
 #endif /* CONFIG_SMP */
@@ -408,8 +409,8 @@
 		/* Enabled, Priority 8 or 9 */
 		openpic_initirq(i, pri, i+offset, (sense & IRQ_POLARITY_MASK),
 				(sense & IRQ_SENSE_MASK));
-		/* Processor 0 */
-		openpic_mapirq(i, 1<<0, 0);
+		/* Boot Processor */
+		openpic_mapirq(i, 1<<OpenPIC_BootCPU, 0);
 	}
 
 	/* Init descriptors */
diff -ur -X /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/platforms/prep_pci.c linuxppc_2_4_devel-240/arch/ppc/platforms/prep_pci.c
--- linuxppc_2_4_devel/arch/ppc/platforms/prep_pci.c	Wed Jun  5 06:02:48 2002
+++ linuxppc_2_4_devel-240/arch/ppc/platforms/prep_pci.c	Wed Jun  5 11:30:13 2002
@@ -873,6 +903,27 @@
 	{0x000, 0x00, 0x00, "",					NULL,			NULL, NULL, NULL, 0x00}
 };
 
+#ifdef CONFIG_PREP_RESIDUAL
+u_int __init
+ibm_prep_boot_cpu(void)
+{
+	int i;
+
+	/* Scan the residual data for the CPU that the firmware used to
+	 * execute the loader - this is our boot CPU.  This is needed
+	 * because the 7043-240 (at least) will not always use CPU 0
+	 * as the boot CPU */
+	for (i = 0; i < res->ActualNumCpus; i++)
+		if (res->Cpus[i].CpuState == CPU_GOOD) {
+			printk(KERN_INFO "PReP boot cpu: %d\n",
+				res->Cpus[i].CpuNumber);
+			return res->Cpus[i].CpuNumber;
+		}
+	
+	return 0;
+}
+#endif
+
 void __init
 ibm_prep_init(void)
 {
@@ -914,6 +965,7 @@
 		return;
 #undef p
 	OpenPIC_Addr = ioremap(addr, len);
+	OpenPIC_BootCPU = ibm_prep_boot_cpu();
 	ppc_md.get_irq = openpic_get_irq;
 
 	OpenPIC_InitSenses = prep_openpic_initsenses;
diff -ur -X /home/leigh/.diffex linuxppc_2_4_devel/include/asm-ppc/open_pic.h linuxppc_2_4_devel-240/include/asm-ppc/open_pic.h
--- linuxppc_2_4_devel/include/asm-ppc/open_pic.h	Thu Jun  6 13:45:39 2002
+++ linuxppc_2_4_devel-240/include/asm-ppc/open_pic.h	Wed Jun  5 11:32:21 2002
@@ -52,6 +52,7 @@
 extern u_int OpenPIC_NumInitSenses;
 extern u_char *OpenPIC_InitSenses;
 extern void* OpenPIC_Addr;
+extern u_int OpenPIC_BootCPU;
 
 /* Exported functions */
 extern void openpic_set_sources(int first_irq, int num_irqs, void *isr);
